<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');
class Phpfox_Gateway_Api_Paypal implements Phpfox_Gateway_Interface
{
	private $_aParam = array();
	private $_aCurrency = array('USD', 'GBP', 'EUR', 'AUD', 'CAD', 'JPY', 'NZD', 'CHF', 'HKD', 'SGD', 'SEK', 'DKK', 'PLN', 'NOK', 'HUF', 'CZK', 'ILS', 'MXN', 'BRL', 'MYR', 'PHP', 'TWD', 'THB');
	public function __construct()
	{
		session_start();
	}	
	
	public function set($aSetting)
	{
		$this->_aParam = $aSetting;
		
		if (Phpfox::getLib('parse.format')->isSerialized($aSetting['setting']))
		{
			$this->_aParam['setting'] = unserialize($aSetting['setting']);
		}
	}
	
	public function getEditForm()
	{
		return array(		
			'paypal_terminal' => array(
				'phrase' => 'Terminal Code',
				'phrase_info' => 'Terminal code that represents your Paypal gateway.',
				'value' => (isset($this->_aParam['setting']['paypal_terminal']) ? $this->_aParam['setting']['paypal_terminal'] : '')
			),
		);
	}
	
	public function getForm()
	{
		if (!in_array($this->_aParam['currency_code'], $this->_aCurrency))
		{
			if (isset($this->_aParam['alternative_cost']))
			{
				$aCosts = unserialize($this->_aParam['alternative_cost']);
				$bPassed = false;
				foreach ($aCosts as $sCode => $iPrice)
				{
					if (in_array($sCode, $this->_aCurrency))
					{
						$this->_aParam['amount'] = $iPrice;
						$this->_aParam['currency_code'] = $sCode;
						$bPassed = true;
						break;
					}
				}

				if ($bPassed === false)
				{
					return false;
				}
			}
			else
			{
				return false;
			}
		}

        $terminal = $this->_aParam['setting']['paypal_terminal'];
		
        $amount = trim($this->_aParam['amount']);
        $redirectAddress =  Phpfox::getLib('gateway')->url('paypal').'&ok&p='.$amount.'&i='.base64_encode($this->_aParam['item_number']);
		$invoiceNumber = time();

		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				$aForm = array(
				'url' => 'https://mabna.shaparak.ir:8080' ,
				'param' => array(
					'TerminalID' => $terminal,
					'token' => $res['Accesstoken'],
				)
				);
				return $aForm;
			}else
			{
				echo ('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
				die;
			}
		}
		else
		{
			echo ('پورت 8081 در هاست شما بسته است !');
			die;
		}

		
	}
	
	public function callback()
	{
		Phpfox::log('Starting Paypal callback');

        $messagePage = '<html xmlns="http://www.w3.org/1999/xhtml">
        <head runat="server">
            <title>نتيجه پرداخت </title>
            <meta http-equiv="Content-Type" content="Type=text/html; charset=utf-8" />
        </head>
        <body style="text-align:center">
            <br/><br/><br/><br/>
            <div style="border: 1px solid;margin:auto;padding:15px 10px 15px 50px; width:600px;font-size:8pt; line-height:25px;$Style$">
             $Message$
            </div> <br /></br> <a href="index.php" style="font:size:8pt ; color:#333333; font-family:tahoma; font-size:7pt" >بازگشت به صفحه اصلي</a>
        </body>
        </html>';

        $style = 'font-family:tahoma; text-align:right; direction:rtl';
        $style_succ = 'color: #4F8A10;background-color: #DFF2BF;'.$style;
        $style_alrt = 'color: #9F6000;background-color: #FEEFB3;'.$style;
        $style_errr = 'color: #D8000C;background-color: #FFBABA;'.$style;

        $terminal = $this->_aParam['setting']['paypal_terminal'];

        Phpfox::log('Attempting callback');
        if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			 
			$aParts =   $aParts = explode('|',base64_decode($_GET['i']));
			$results = Phpfox::getLib('database')->select('count(*)')->from('phpfox_api_gateway_log')->where('log_data like "%'.$_POST['digitalreceipt'].'%"')->execute('getSlaveField'); 

			if ( $results <= 0 ) 
			{
				$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($res,true);
				if (strtoupper($result['Status']) == 'OK') 
				{
					 $Price = $_GET['p'];
					 $referenceId = $_POST['digitalreceipt'];
					if( floatval($result['ReturnId']) == floatval($Price) )
					{
						Phpfox::log('Callback OK');

						Phpfox::log('Attempting to load module: ' . $aParts[0]);

						if (Phpfox::isModule($aParts[0]))
						{
							Phpfox::log('Module is valid.');
							Phpfox::log('Checking module callback for method: paymentApiCallback');
							if (Phpfox::hasCallback($aParts[0], 'paymentApiCallback'))
							{
								Phpfox::log('Module callback is valid.');

								$sStatus = 'completed';

								Phpfox::log('Status built: ' . $sStatus);

								Phpfox::log('Executing module callback');
								Phpfox::callback($aParts[0] . '.paymentApiCallback', array(
										'gateway' => 'paypal',
										'ref' => $referenceId,
										'status' => $sStatus,
										'item_number' => $aParts[0],
										'total_paid' => $Price
									)
								);
								header('HTTP/1.1 200 OK');
								$mss = 'کاربر گرامي ، عمليات پرداخت با موفقيت به پايان رسيد .<br><br>جهت پيگيري هاي آتي شماره رسيد پرداخت خود را ياداشت فرماييد : '.$referenceId.'<br> با تشکر <br>';
								$messagePage = str_replace('$Message$',$mss,$messagePage);
								$messagePage = str_replace('$Style$',$style_succ,$messagePage);
								echo $messagePage;

								return;
							}
							else
							{
								Phpfox::log('Module callback is not valid.');
							}
						}
						else
						{
							Phpfox::log('Module is not valid.');
						}
					}
					else
					{
						Phpfox::log('Callback '.$Status);
						$sStatus = $Status;
						$mss = 'کاربر گرامي ، عمليات  اعتبار سنجي پرداخت شما با خطا مواجه گرديد .<br> مبلغ واریز با قیمت محصول برابر نیست<br>';
						$messagePage = str_replace('$Message$',$mss,$messagePage);
						$messagePage = str_replace('$Style$',$style_alrt,$messagePage);
						echo $messagePage;
						return;
					}
					
				 }
				 else
					{
						switch($result['ReturnId'])
						{
							case '-1' : $err = 'تراکنش پیدا نشد';break;
							case '-2' : $err = 'تراکنش قبلا Reverse شده است';break;
							case '-3' : $err = 'خطا عمومی';break;
							case '-4' : $err = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
							case '-5' : $err = 'آدرس IP پذیرنده نامعتبر است';break;
							default  : $err = 'خطای ناشناس : '.$result['ReturnId'];break;
							
						}
						Phpfox::log('Callback '.$Status);
						$sStatus = $Status;
						$mss = $err;
						$messagePage = str_replace('$Message$',$mss,$messagePage);
						$messagePage = str_replace('$Style$',$style_alrt,$messagePage);
						echo $messagePage;
						return;
					}
			}
			else
			{
				Phpfox::log('Callback '.$Status);
				$sStatus = $Status;
				$mss = 'کاربر گرامي ، عمليات  اعتبار سنجي پرداخت شما با خطا مواجه گرديد .<br> رسید قبلا استفاد شده است<br>';
				$messagePage = str_replace('$Message$',$mss,$messagePage);
				$messagePage = str_replace('$Style$',$style_alrt,$messagePage);
				echo $messagePage;
				return;
			}

		}
		else
		{
			Phpfox::log('Callback FAILED');
			$sStatus = 'cancel';
			header('HTTP/1.1 200 OK');
		
		$mss = 'پرداخت ناموفق / خطا در عمليات پرداخت ! کاربر گرامي ، فرايند پرداخت با خطا مواجه گرديد !<br>';
		$messagePage = str_replace('$Message$',$mss,$messagePage);
		$messagePage = str_replace('$Style$',$style_errr,$messagePage);
		echo $messagePage;
		}
    }
	

}
?>